/*************************************************** */
/* Rule Set Based Access Control                     */
/* Author and (c) 1999-2009: Amon Ott <ao@rsbac.org> */
/* Memory allocation                                 */
/* Last modified: 15/Oct/2009                        */
/*************************************************** */

#ifndef __RSBAC_RKMEM_H
#define __RSBAC_RKMEM_H

#include <linux/init.h>
#include <linux/slab.h>
#include <linux/vmalloc.h>
#include <linux/timer.h>

#ifdef CONFIG_MMU
#define RSBAC_MAX_KMALLOC 131072
#else
#ifndef CONFIG_LARGE_ALLOCS
#define RSBAC_MAX_KMALLOC 1048576
#else
#define RSBAC_MAX_KMALLOC 33554432
#endif
#endif

/* alloc mem spinlock safe with GFP_ATOMIC */
extern void * rsbac_kmalloc (size_t size);

/* alloc outside locks with GFP_KERNEL */
extern void * rsbac_kmalloc_unlocked (size_t size);

extern void rsbac_kfree (const void * objp);
#endif
